package chats

import (
	"clickandjoin.app/managementsystem/modules/scylladb"
	"clickandjoin.app/managementsystem/modules/structs"
	gocnjhelper "git.clickandjoin.umbach.dev/ClickandJoin/go-cnj-helper"
	"git.clickandjoin.umbach.dev/ClickandJoin/go-cnj-helper/dbstructs"
	"github.com/gofiber/fiber/v2"
)

func GetAllChats(c *fiber.Ctx) error {
	// swagger:operation GET /chats chats chatsGetAllChats
	// ---
	// summary: List of chats
	// consumes:
	// - application/json
	// produces:
	// - application/json
	// responses:
	//  '200':
	//    schema:
	//      "$ref": "#/definitions/ChatsResponse"
	//  '500':
	//    description: Internal server error

	var chats []dbstructs.Chat

	q := scylladb.Session.Query(gocnjhelper.DbMChats.SelectAll())

	if err := q.SelectRelease(&chats); err != nil {
		gocnjhelper.LogErrorf("Failed to get chats, err: %s", err)
	}

	return c.JSON(structs.ChatsResponse{Chats: chats})
}
